{
#include "Riostream.h"
//
// To see the output of this macro, click  here 
//    Simple example illustrating how to use the C++ interpreter	
//    to fill histograms in a loop and show the graphics results
//

// iDist = 1 : Thrust
//         2 : ...
  gROOT->Reset();

string sMatch="";
vector<string> sDist;
//sDist.push_back("Thrust");
//sDist.push_back("ThrustTail");
//sDist.push_back("ThrustNorm");
//sDist.push_back("CNorm");
//sDist.push_back("C");
//sDist.push_back("Clin");
//sDist.push_back("DNorm");
sDist.push_back("D");
//sDist.push_back("Dlin");
//sDist.push_back("Oblateness");
//sDist.push_back("Major");
//sDist.push_back("Minor");
//sDist.push_back("nQuarks");
//sDist.push_back("nPartons");
//sDist.push_back("Jet3ILog");
//sDist.push_back("Jet4ILog");
//sDist.push_back("Jet5ILog");
//sDist.push_back("Jet3ELog");
//sDist.push_back("Jet4ELog");
//sDist.push_back("Jet5ELog");


double xMin=0.0;
double xMax=1.0;
double yMin=0.0;
double yMax=1.0;
bool logy = false;
bool forcelog = false;
bool forcelin = false;
bool forceStep= false;
string style  = "same,c";
bool showGrid = true;
bool showHad  = true;
bool showSct  = false;
string align  = "L";
string alignLeg  = "L";

// Set default title
string processTit="Z#rightarrowq#bar{q}";
string title;
for (int i=0;i < sDist.size(); i++) {
  title += sDist[i];
  if (i+1 < sDist.size()) title += ", "; 
}  
// Set default x title
string xtitle = title;
string ytitle = title;
string globalTit = sDist[0];
   
if (sDist[0] == "Thrust") {
  xMax=0.1;
  yMin=0.0;
  yMax=20.;
  align= "R";
  xtitle = "1-T";
  ytitle = "1/#\sigma_{NLO} d#sigma_{MC}/d(1-T)";
  globalTit = "Thrust";
}
else if (sDist[0] == "ThrustTail" || sDist[0] == "ThrustCoarse") {
  xMax=0.42;
  yMin=0.001;
  yMax=20.;
  logy = true;
  align= "R";
  xtitle = "1-T";
  ytitle = "1/#sigma_{NLO} d#sigma_{MC}/d(1-T)";
  showhad=false;
  globalTit = "Thrust";
} 
else if (sDist[0] == "ThrustNorm") {
  xMax=0.4;
  yMin=0.0;
  yMax=0.5;
  align= "R";
  xtitle = "1-T";
  ytitle = "(1-T) 1/#sigma_{NLO} d#sigma_{MC}/d(1-T)";  
}
else if (sDist[0] == "CNorm") {
  xMax=1.0;
  yMin=0.0;
  yMax=0.6;
  align= "R";
  xtitle = "C";
  ytitle = "C 1/#\sigma_{NLO} d#sigma_{MC}/dC";
}
else if (sDist[0] == "C") {
  xMax=1.0;
  yMin=0.001;
  yMax=13.0;
  logy = true;
  align= "R";
  xtitle = "C";
  ytitle = "1/#\sigma_{NLO} d#sigma_{MC}/dC";
}
else if (sDist[0] == "Clin") {
  xMax=0.5;
  yMin=0.0;
  yMax=5.0;
  logy = false;
  sDist[0]="C";  
  align= "R";
  alignLeg="R";
  globalTit = "C";
  title  = "C";
  xtitle = "C";
  ytitle = "1/#\sigma_{NLO} d#sigma_{MC}/dC";
}
else if (sDist[0] == "DNorm") {
  xMax=1.0;
  yMin=0.0;
  yMax=0.3;
  align= "R";
  alignLeg="R";
  xtitle = "D";
  ytitle = "D 1/#\sigma_{NLO} d#sigma_{MC}/dD";
}
else if (sDist[0] == "D") {
  xMax=1.0;
  yMin=0.001;
  yMax=10.0;
  logy = true;
  align= "R";
  xtitle = "D";
  ytitle = "1/#\sigma_{NLO} d#sigma_{MC}/dD";
}
else if (sDist[0] == "Dlin") {
  xMax=0.5;
  yMin=0.0;
  yMax=5.0;
  logy = false;
  sDist[0]="D";  
  align= "R";
  alignLeg="R";
  globalTit = "D";
  title  = "D";
  xtitle = "D";
  ytitle = "1/#\sigma_{NLO} d#sigma_{MC}/dD";
}
else if (sDist[0] == "Oblateness") {
  xMax=0.6;
  yMin=0.001;
  yMax=20.0;
  logy = true;
  align= "R";
  xtitle = "O";
  ytitle = "1/#\sigma_{NLO} d#sigma_{MC}/dO";
}
else if (sDist[0] == "Major") {
  xMax=0.7;
  yMin=0.001;
  yMax=10.0;
  logy = true;
  align= "R";
  xtitle = "Major";
  ytitle = "1/#\sigma_{NLO} d#sigma_{MC}/dMaj";
}
else if (sDist[0] == "Minor") {
  xMax=0.5;
  yMin=0.001;
  yMax=20.0;
  logy = true;
  align= "R";
  xtitle = "Minor";
  ytitle = "1/#\sigma_{NLO} d#sigma_{MC}/dMin";
}
else if (sDist[0] == "nQuarks") {
  xMin=0.5;
  xMax=5.5;
  yMin=0.001;
  yMax=1.0;
  logy = true;
  showHad=false;
  showGrid=false;
  style = "same";
  align= "R";
  ytitle = "P(nQ)";
}
else if (sDist[0] == "nPartons") {
  xMin=0.0;
  xMax=30.5;
  yMin=0.001;
  yMax=1.0;
  logy = true;
  showHad=false;
  showGrid=false;
  style="same";
}
else if (sDist[0] == "Jet3ILog") {
  xMin=-4.0;
  xMax=-1.5;
  yMin=0.0;
  yMax=1.0;
  align= "R";
  xtitle = "log_{10}(y_{cut})";
  ytitle = "Inclusive n-Jet Fraction";
  globalTit = "Incl 3-";
  if (sDist.size() >= 2) globalTit += ", 4-";
  if (sDist.size() >= 3) globalTit += ", 5-";
  globalTit += "jet fraction";
}
else if (sDist[0] == "Jet3ELog") {
  xMin=-4.0;
  xMax=-1.5;
  yMin=0.0;
  yMax=0.5;
  xtitle = "log_{10}(y_{cut})";
  ytitle = "Exclusive n-Jet Fraction";
  globalTit = "Excl 3-";
  if (sDist.size() >= 2) globalTit += ", 4-";
  if (sDist.size() >= 3) globalTit += ", 5-";
  globalTit += "jet fraction";
}
c1 = new TCanvas("c1","Vincia Plot Macro",200,10,600,400);
if (showGrid) c1->SetGrid();  
if (logy) c1->SetLogy();
   c1->SetFillColor(0);
   c1->SetBorderMode(0);
   c1->SetBorderSize(0);
if (showGrid) {
   c1->SetGridx();
   c1->SetGridy();
}
   c1->SetTickx();
   c1->SetTicky();
   c1->SetLeftMargin(0.133449);
   c1->SetRightMargin(0.116118);
   c1->SetBottomMargin(0.163534);
   c1->SetFrameLineWidth(2);
   c1->SetFrameLineWidth(2);

  TH2D *axeshisto = new TH2D("axeshisto",title.c_str(),2,xMin,xMax,2,yMin,yMax);
  axeshisto->SetStats(0);
  axeshisto->GetXaxis()->SetTitle(xtitle.c_str());
  axeshisto->GetXaxis()->SetNdivisions(505);
  axeshisto->GetXaxis()->SetLabelFont(42);
  axeshisto->GetXaxis()->SetLabelSize(0.05);
  axeshisto->GetXaxis()->SetTitleSize(0.05);
  axeshisto->GetXaxis()->SetTitleFont(42);
  axeshisto->GetYaxis()->SetTitle(ytitle.c_str());
  axeshisto->GetYaxis()->SetNdivisions(508);
  axeshisto->GetYaxis()->SetLabelFont(42);
  axeshisto->GetYaxis()->SetLabelSize(0.05);
  axeshisto->GetYaxis()->SetTitleSize(0.05);
  axeshisto->GetYaxis()->SetLabelOffset(0.01);
  axeshisto->GetYaxis()->SetTitleOffset(1.0);
  axeshisto->GetYaxis()->SetTitleFont(42);
  axeshisto->SetTitle("");
  axeshisto->Draw();


// Open his files
string bName="vc01";
 string ord="ord";
 string evt="ev1";
string sMaxName=bName+"-max-ev1-kin1-had1q1-"+ord+"-p5-q3.root";
string sMedName=bName+"-def-ev1-kin1-had1q1-"+ord+"-p5-q3.root";
string sMinName=bName+"-min-ev1-kin1-had1q1-"+ord+"-p5-q3.root";
string sDefName=bName+"-def-ev1-kin1-had1q1-"+ord+"-p5-q3.root";
string sSctName=bName+"-sct-ev1-kin1-had1.10-ord-p5-q3.root";
string sPytName=bName+"-pyt-tun0-q3.root";
string sPytHadName=bName+"-pyt-tun0-q3-had.root";
string sDefHadName=bName+"-def-ev1-kin1-had-1q1-ord-p5-q3-had.root";
string sSctHadName=bName+"-sct-ev1-kin1-had1.10-ord-p5-q3-had.root";
TFile vcmax(sMaxName.c_str());
TFile vcmin(sMinName.c_str());
TFile vcmed(sMedName.c_str());
TFile vcdef(sDefName.c_str());
TFile pyt(sPytName.c_str());
if (showHad == true) {
  TFile pythad(sPytHadName.c_str());
  TFile vinhad(sDefHadName.c_str());
}
if (showSct == true) {
  TFile vcsct(sSctName.c_str());
  TFile vcscthad(sSctHadName.c_str());
}
TFile mydum("dum.root");
string vcdist=sDist[0];
if (sDist[0] == "ThrustTail") vcdist="ThrustTail";
 TH1F Tmax = *(TH1F*)vcmax.Get(vcdist.c_str());
 TH1F Tmin = *(TH1F*)vcmin.Get(vcdist.c_str());
 TH1F Tmed = *(TH1F*)vcmed.Get(vcdist.c_str());
 //  TH1F Tmed = 0.5*(Tmax+Tmin);
 TH1F Tdef = *(TH1F*)vcdef.Get(vcdist.c_str());
 string pydist=sDist[0];
if (sDist[0] == "ThrustCoarse") {
 vcdist="ThrustTail";
} else if (sDist[0] == "Thrust") {
 TH1F Ttmp = Tmax;
 Tmax = Tmin;
 Tmin = Ttmp;
}
TH1F Tpyt = *(TH1F*)pyt.Get(sDist[0].c_str());
if (showHad == true) {
  TH1F Tpythad = *(TH1F*)pythad.Get(pydist.c_str());
  TH1F Tvinhad = *(TH1F*)vinhad.Get(vcdist.c_str());
}
// For the time being, create "med" as average

// Choose a color
  Int_t cWhite;   // for color index setting
  cWhite = TColor::GetColor("#fffffd");
  Int_t cShade;   // for color index setting
  cShade = TColor::GetColor("#ffff00");
if (sDist[0] == "Thrust") {
  cShade = TColor::GetColor("#ffcc00");
}
  // Max (filled)
  Tmax.SetStats(0);
  Tmax.SetFillColor(cShade);
  Tmax.SetLineWidth(2);
  Tmax.Draw(style.c_str());
// Min (filled in white)
  Tmin.SetStats(0);
  Tmin.SetFillColor(cWhite);
  Tmin.SetLineWidth(2);
  Tmin.Draw(style.c_str());
// Med (thin line)
  Tmed.SetLineStyle(1);
  Tmed.Draw(style.c_str());
// Def (thin dots)
  Tdef.SetLineStyle(3);
  Tdef.Draw(style.c_str());
// Pyt (thin line)
  Tpyt->SetLineColor(2);
  Tpyt->SetLineStyle(1);
  Tpyt->SetLineWidth(1);
  Tpyt.Draw(style.c_str());
// Pythia with hadronization
  if (showHad) {
    Tpythad.SetLineColor(2);
    Tpythad.SetLineStyle(2);
    Tpythad.Draw(style.c_str());
    Tvinhad.SetLineColor(1);
    Tvinhad.SetLineWidth(2);
    Tvinhad.SetLineStyle(2);
    Tvinhad.Draw(style.c_str());
  }
// Redraw all curves without filling (to be sure we see them)
  TH1F TmaxCopy1(Tmax);
  TmaxCopy1.SetFillColor(0);
  TH1F TmedCopy1(Tmed);
  TmedCopy1.SetFillColor(0);
  TH1F TdefCopy1(Tdef);
  TdefCopy1.SetFillColor(0);
  TH1F TminCopy1(Tmin);
  TminCopy1.SetFillColor(0);
  TmaxCopy1.Draw(style.c_str());
  TmedCopy1.Draw(style.c_str());
  TdefCopy1.Draw(style.c_str());
  TminCopy1.Draw(style.c_str());

if (sDist.size() >= 2) {

  TH1F Tmax2 = *(TH1F*)vcmax.Get(sDist[1].c_str());
  TH1F Tmin2 = *(TH1F*)vcmin.Get(sDist[1].c_str());
  //  TH1F Tmed2 = 0.5*(Tmax2+Tmin2);
  TH1F Tmed2 = *(TH1F*)vcmed.Get(sDist[1].c_str());
  TH1F Tpyt2 = *(TH1F*)pyt.Get(sDist[1].c_str());
  if (showhad) {
    TH1F Tpythad2 = *(TH1F*)pythad.Get(sDist[1].c_str());
    TH1F Tvinhad2 = *(TH1F*)vinhad.Get(sDist[1].c_str());
  }
// For the time being, create "med" as average

// Choose a color
  Int_t cWhite;   // for color index setting
  cWhite = TColor::GetColor("#fffffd");
  Int_t cShade;   // for color index setting
  cShade = TColor::GetColor("#d4ff00");
  // Max (filled)
  Tmax2.SetStats(0);
  Tmax2.SetFillColor(cShade);
  Tmax2.SetLineWidth(2);
  Tmax2.Draw(style.c_str());
// Min (filled in white)
  Tmin2.SetStats(0);
  Tmin2.SetFillColor(cWhite);
  Tmin2.SetLineWidth(2);
  Tmin2.Draw(style.c_str());
// Med (thin line)
   Tmed2.Draw(style.c_str());
// Pyt (thin line)
  Tpyt2.SetLineColor(2);
  Tpyt2.Draw(style.c_str());
// Pythia with hadronization
  if (showHad) {
    Tpythad2.SetLineColor(2);
    Tpythad2.SetLineStyle(2);
    Tpythad2.Draw(style.c_str());
    Tvinhad2.SetLineColor(1);
    Tvinhad2.SetLineStyle(2);
    Tvinhad2.SetLineWidth(2);
    Tvinhad2.Draw(style.c_str());
  }

// Redraw all curves without filling (to be sure we see them)
  TH1F TmaxCopy2(Tmax2);
  TmaxCopy2.SetFillColor(0);
  TH1F TmedCopy2(Tmed2);
  TmedCopy2.SetFillColor(0);
  TH1F TminCopy2(Tmin2);
  TminCopy2.SetFillColor(0);
  TminCopy2.Draw(style.c_str());
  TmedCopy2.Draw(style.c_str());
  TmaxCopy2.Draw(style.c_str());
  TmaxCopy1.Draw(style.c_str());
  TmedCopy1.Draw(style.c_str());
  TminCopy1.Draw(style.c_str());
 }

if (sDist.size() >= 3) {

  TH1F Tmax3 = *(TH1F*)vcmax.Get(sDist[2].c_str());
  TH1F Tmin3 = *(TH1F*)vcmin.Get(sDist[2].c_str());
  //  TH1F Tmed3 = 0.5*(Tmax3+Tmin3);
  TH1F Tmed3 = *(TH1F*)vcmed.Get(sDist[2].c_str());
  TH1F Tpyt3 = *(TH1F*)pyt.Get(sDist[2].c_str());
  if (showhad) {
    TH1F Tpythad3 = *(TH1F*)pythad.Get(sDist[2].c_str());
    TH1F Tvinhad3 = *(TH1F*)vinhad.Get(sDist[2].c_str());
  }
// For the time being, create "med" as average

// Choose a color
  Int_t cWhite;   // for color index setting
  cWhite = TColor::GetColor("#fffffd");
  Int_t cShade;   // for color index setting
  cShade = TColor::GetColor("#00ff00");
  // Max (filled)
  Tmax3.SetStats(0);
  Tmax3.SetFillColor(cShade);
  Tmax3.SetLineWidth(2);
  Tmax3.Draw(style.c_str());
// Min (filled in white)
  Tmin3.SetStats(0);
  Tmin3.SetFillColor(cWhite);
  Tmin3.SetLineWidth(2);
  Tmin3.Draw(style.c_str());
// Med (thin line)
   Tmed3.Draw(style.c_str());
// Pyt (thin line)
  Tpyt3.SetLineColor(2);
  Tpyt3.Draw(style.c_str());
// Pythia with hadronization
  if (showHad) {
    Tpythad3.SetLineColor(2);
    Tpythad3.SetLineStyle(2);
    Tpythad3.Draw(style.c_str());
    Tvinhad3.SetLineColor(1);
    Tvinhad3.SetLineStyle(2);
    Tvinhad3.SetLineWidth(2);
    Tvinhad3.Draw(style.c_str());
  }
// Redraw all curves without filling (to be sure we see them)
  TH1F TmaxCopy3(Tmax3);
  TmaxCopy3.SetFillColor(0);
  TH1F TmedCopy3(Tmed3);
  TmedCopy3.SetFillColor(0);
  TH1F TminCopy3(Tmin3);
  TminCopy3.SetFillColor(0);
  TmaxCopy3.Draw(style.c_str());
  TmaxCopy2.Draw(style.c_str());
  TmaxCopy1.Draw(style.c_str());
  TmedCopy3.Draw(style.c_str());
  TmedCopy2.Draw(style.c_str());
  TmedCopy1.Draw(style.c_str());
  TminCopy3.Draw(style.c_str());
  TminCopy2.Draw(style.c_str());
  TminCopy1.Draw(style.c_str());

}
/*

// Create some histograms.
  total  = new TH1F("total","This is the total distribution",100,-4,4);
  main   = new TH1F("main","Main contributor",100,-4,4);
  s1     = new TH1F("s1","This is the first signal",100,-4,4);
  s2     = new TH1F("s2","This is the second signal",100,-4,4);
  total->Sumw2();   // this makes sure that the sum of squares of weights will be stored
  total->SetMarkerStyle(21);
  total->SetMarkerSize(0.7);
  main->SetFillColor(16);
  s1->SetFillColor(42);
  s2->SetFillColor(46);
  TSlider *slider = 0;

// Fill histograms randomly
  gRandom->SetSeed();
  const Int_t kUPDATE = 500;
  Float_t xs1, xs2, xmain;
  for ( Int_t i=0; i<10000; i++) {
     xmain = gRandom->Gaus(-1,1.5);
     xs1   = gRandom->Gaus(-0.5,0.5);
     xs2   = gRandom->Gaus(1,0.3);
     main->Fill(xmain);
     s1->Fill(xs1,0.3);
     s2->Fill(xs2,0.2);
     total->Fill(xmain);
     total->Fill(xs1,0.3);
     total->Fill(xs2,0.2);
     if (i && (i%kUPDATE) == 0) {
        if (i == kUPDATE) {
           total->Draw("e1p");
           main->Draw("same");
           s1->Draw("same");
           s2->Draw("same");
           c1->Update();
           slider = new TSlider("slider","test",4.2,0,4.6,total->GetMaximum(),38);
           slider->SetFillColor(46);
        }
        if (slider) slider->SetRange(0,Float_t(i)/10000.);
        c1->Modified();
        c1->Update();
     }
  }
  slider->SetRange(0,1);
*/

// Write title and Legend
double dx = xMax-xMin; 
double xL1 = xMin+0.05*dx;
double xR1 = xMax-0.05*dx;
double x1  = xL1; 
if (align == "R") x1=xR1;
double dy = yMax-yMin;
double y1  = yMax - 0.1*dy;
double y2  = yMax - 0.18*dy;
double y3  = yMax - 0.23*dy;
if (logy) {
  dy = log(yMax)-log(yMin);
  double logy1 = log(yMin)+0.9*dy;
  double logy2 = log(yMin)+0.82*dy;
  double logy3 = log(yMin)+0.77*dy;
  y1 = exp(logy1);
  y2 = exp(logy2);
  y3 = exp(logy3);
}

   TLatex *   tex = new TLatex(x1,y1,processTit.c_str());
   tex->SetTextSize(0.06);
   tex->SetLineWidth(2);
   tex->SetTextAlign(11);
   if (align == "R") tex->SetTextAlign(31);
   tex->Draw();
   tex = new TLatex(x1,y2,"Vincia 1.017 + Pythia 8.130");
   tex->SetTextAlign(11);
   if (align == "R") tex->SetTextAlign(31);
   tex->SetTextFont(42);
   tex->SetTextSize(0.04);
   tex->SetLineWidth(2);
   tex->Draw();
   tex = new TLatex(x1,y3,globalTit.c_str());
   if (align == "R") tex->SetTextAlign(31);
   tex->SetTextSize(0.05);
   tex->SetLineWidth(2);
   tex->SetTextAlign(12);
   if (align == "R") tex->SetTextAlign(32);
   tex->Draw();
   
  c1->Modified();
  gPad->RedrawAxis();

// Overplot LEP data
bool useLEP=false;
if (sDist[0] == "C" || sDist[0] == "CNorm" || sDist[0] == "Major" || sDist[0] == "Oblateness" || sDist[0] == "D" ||  sDist[0] == "DNorm" || sDist[0] == "Thrust" || sDist[0] == "ThrustNorm" || sDist[0] == "ThrustCoarse" || sDist[0] == "ThrustTail") {
//   example of macro to read data from an ascii file and
//   create a root file with an histogram and an ntuple.
  useLEP=true;
}

double xLeg=0.16;
if (alignLeg == "R") xLeg=0.49;
double xSubTit=0.16;
if (align == "R") xSubTit=0.65;
double xLegEnd=xLeg+0.5;
double xSubTitEnd=xSubTit+0.34;
if (showHad) {
   TLegend *subtit = new TLegend(xSubTit,0.6,xSubTitEnd,0.68,NULL,"rNDC");
   subtit->SetBorderSize(0);
   subtit->SetFillStyle(0);
   TLegendEntry *entry=subtit->AddEntry("NULL","parton-level","l");
   entry->SetLineColor(1);
   entry->SetTextAlign(12);
   entry->SetTextSize(0.038);
   entry->SetTextColor(1);
   TLegendEntry *entry=subtit->AddEntry("NULL","hadron-level","l");
   entry->SetLineColor(1);
   entry->SetLineStyle(2);
   entry->SetTextAlign(12);
   entry->SetTextSize(0.038);
   entry->SetTextColor(1);   
   subtit->Draw();
} else {
   TLegend *subtit = new TLegend(xSubTit,0.7,xSubTitEnd,0.8,NULL,"rNDC");
}

if (useLEP) {
  TLegend *leg = new TLegend(xLeg,0.18,xLegEnd,0.42,NULL,"rNDC");
} else {
  TLegend *leg = new TLegend(xLeg,0.18,xLegEnd,0.36,NULL,"rNDC");
}
leg->SetBorderSize(0);
leg->SetFillStyle(0);
string sVincia = "Vincia LL^{max}_{min}";
if (sMatch == "-m1-T3") 
  sVincia = sVincia + " #otimes LO_{3}";
else if (sMatch == "-m2-T3")
  sVincia = sVincia + " #oplus LO_{3}";
else if (sMatch == "-m1-T4")
  sVincia = sVincia + " #otimes LO_{3,4}";
else if (sMatch == "-m2-T4")
  sVincia = sVincia + " #oplus LO_{3,4}";
else if (sMatch == "-m1-L2-T3")
  sVincia = sVincia + " #otimes NLO_{2} #otimes LO_{3}";
else if (sMatch == "-m2-L2-T3")
  sVincia = sVincia + " #oplus NLO_{2} #oplus LO_{3}";
else if (sMatch == "-m1-L2-T4")
  sVincia = sVincia + " #otimes NLO_{2} #otimes LO_{3,4}";
else if (sMatch == "-m2-L2-T4")
  sVincia = sVincia + " #oplus NLO_{2} #oplus LO_{3,4} Hyb";


if (useLEP) {
   ifstream in;
// we assume a file basic.dat in the current directory
// this file has 3 columns of float data
   string lepfile = "LEP-"+sDist[0]+"91.vec";
   if (sDist[0] == "CNorm") lepfile = "LEP-C91.vec";
   if (sDist[0] == "DNorm") lepfile = "LEP-D91.vec";
   if (sDist[0] == "ThrustNorm" || sDist[0] == "ThrustCoarse" || sDist[0] == "ThrustTail" ) lepfile = "LEP-Thrust91.vec";
   in.open(lepfile.c_str());

   Float_t xlo,xhi,y,sigstat,sigsys,sigsys2;
   Int_t nlines = 0;
   Float_t x[100],sig[100],ex[100],ey[100];
   Float_t xB1[100],xB2[100];
   Float_t sumsig=0.0;
   
   while (1) {
     in >> xlo >> xhi >> y >> sigstat >> sigsys >> sigsys2;
      if (!in.good()) break;
      if (nlines < 5) printf("xlo=%8f, xhi=%8f, y=%8f\n",xlo,xhi,y);
      x[nlines]=(0.5*((xhi)+(xlo)));
      if (sDist[0] == "Thrust" || sDist[0] == "ThrustTail" ||  
	  sDist[0] == "ThrustCoarse"|| sDist[0] == "ThrustNorm") 
	x[nlines]=(0.5*((1-xhi)+(1-xlo)));
      if (sDist[0] == "Minor") x[nlines]=exp(x[nlines]);
      sig[nlines]=(y);
      if (sDist[0] == "CNorm" || sDist[0] == "DNorm" || 
	  sDist[0] == "ThrustNorm" ) sig[nlines] *= x[nlines];
      ex[nlines]=(0.0);
      ey[nlines]=sqrt(pow(sigstat,2)+pow(sigsys,2)+pow(sigsys2,2));
      if (sDist[0] == "CNorm" || sDist[0] == "DNorm" || 
	  sDist[0] == "ThrustNorm" ) ey[nlines] *= x[nlines];      
      nlines++;
      sumsig += y*(xhi-xlo);
   }
   printf(" found %d pointsn",nlines);
   cout << " Total sum of LEP points * BW = "<<sumsig<<endl;
   
   // Normalize to 1/sigma
   if (sDist[0]=="Oblateness") {
     for (int i = 0; i<100 ; i++) {
       sig[i] /= sumsig;
     }
   }

   gr = new TGraphErrors(60,x,sig,ex,ey);
   gr->SetMarkerColor(4);
   gr->SetMarkerSize(0.5);
   gr->SetMarkerStyle(21);
   gr->Draw("same,p");

   in.close();

   // D from L3
   // http://durpdg.dur.ac.uk/spires/find/hep/www?eprint=hep-ex/0406049

   // Rest from ALEPH

   string leptit="ALEPH";
   if (sDist[0] == "D" || sDist[0] == "DNorm") {
     leptit = "L3";
   }
   TLegendEntry *entry=leg->AddEntry("gr",leptit.c_str(),"p");
   entry->SetLineColor(cShade);
   entry->SetMarkerColor(4);
   entry->SetMarkerSize(0.5);
   entry->SetMarkerStyle(21);
   entry->SetTextAlign(12);
   entry->SetTextSize(0.04);
   entry->SetTextColor(1);

}

   TLegendEntry *entry=leg->AddEntry("NULL",sVincia.c_str(),"l");
   entry->SetLineColor(1);
   entry->SetFillStyle(0);
   entry->SetFillColor(0);
   entry->SetLineStyle(1);
   entry->SetLineWidth(2);
   entry->SetTextAlign(12);
   entry->SetTextSize(0.04);
   entry->SetTextColor(1);

   entry=leg->AddEntry("NULL","Pythia LL^{ } #otimes NLO_{2} #otimes LO_{3}","l");
   Int_t ci;   // for color index setting
   entry->SetLineColor(2);
   entry->SetLineStyle(1);
   entry->SetLineWidth(1);
   entry->SetMarkerColor(2);
   entry->SetMarkerStyle(1);
   entry->SetMarkerSize(1);
   entry->SetTextAlign(12);
   entry->SetTextSize(0.04);
   entry->SetTextColor(1);

  string footnote="#alpha_{s}(MZ)=0.137 and #mu_{PS}= pT";
if (sMatch.find("alp") != string::npos) {
  string footnote="#alpha_{s}(MZ)=0.137 and 1/2pT < #mu_{PS}< 2pT";
} 

   entry=leg->AddEntry("NULL",footnote.c_str(),"");
   entry->SetFillStyle(0);
   entry->SetLineColor(0);
   entry->SetLineStyle(0);
   entry->SetLineWidth(0);
   entry->SetMarkerColor(0);
   entry->SetMarkerStyle(0);
   entry->SetMarkerSize(0);
   entry->SetTextAlign(12);
   entry->SetTextSize(0.03);
   entry->SetTextColor(1);

   leg->Draw();


// Print the fintal output
   string outfile = "LEP-"+sDist[0]+"91"+sMatch;
string jpgfile = outfile+".jpg";
string pngfile = outfile+".png";
string epsfile = outfile+".eps";
string giffile = outfile+".gif";

   c1->Print(epsfile.c_str()); 
   c1->Print(jpgfile.c_str()); 
   c1->Print(pngfile.c_str()); 
   c1->Print(giffile.c_str()); 


}
